/*
   LCD
  
  CodeVisionAVR C Compiler
  (C) 2000-2002 HP InfoTech S.R.L.
  www.hpinfotech.ro
  
  : AT90S8515
   : SMALL
    : 128 
  
   - LCD 2x16, 
    PORTC STK500  :
  [LCD]    [ PORTC STK500]
   1 GND - 9 GND
   2 +5V - 10 VCC
   3 VLC -   LCD  0..1V
   4 RS  - 1 PC0
   5 RD  - 2 PC1
   6 EN  - 3 PC2
   11 D4 - 5 PC4
   12 D5 - 6 PC5
   13 D6 - 7 PC6
   14 D7 - 8 PC7
*/

// LCD    PORTC
//   lcd.h   ..\inc
#asm
  .equ __lcd_port=0x1B ;PORTA
#endasm

//    LCD
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



void main(void)
{
  //  LCD 
  // 2   16 
  lcd_init(16);
  
  //     LCD
  lcd_gotoxy(0,1);
  
  //  
  lcd_putsf("Hello world");
  
  //  
  while (1);
}

